//+------------------------------------------------------------------+
//|                                                       H2DTsr.mq4 |
//|                               Copyright  2009, HowToDayTrade.ws |
//|                                      http://www.howtodaytrade.ws |
//+------------------------------------------------------------------+
#property copyright "Matt Sharp"
#property link      "http://www.howtodaytrade.ws"


double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Silver
#property indicator_color2 Silver
#property indicator_color3 LimeGreen
#property indicator_color4 LimeGreen
#property indicator_color5 Blue
#property indicator_color6 Blue
#property indicator_color7 Red
#property indicator_color8 Red
//---- input parameters
extern color     PivotLabelColor=White;
extern int       fontsize=8;
extern int       LabelShift = 0;

//---- buffers
datetime LabelShiftTime;

int KG;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW,STYLE_DOT,2,Magenta);
   SetIndexDrawBegin(0,KG-1);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexLabel(0,"Resistance M15");
   SetIndexArrow(0, 158);
   SetIndexStyle(1,DRAW_ARROW,STYLE_DOT,2,Magenta);
   SetIndexDrawBegin(1,KG-1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexLabel(1,"Support M15");
   SetIndexArrow(1, 158);
   SetIndexStyle(2,DRAW_ARROW,STYLE_DOT,2,LimeGreen);
   SetIndexDrawBegin(2,KG-1);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexLabel(2,"Resistance H1");
   SetIndexArrow(2, 158);
   SetIndexStyle(3,DRAW_ARROW,STYLE_DOT,2,LimeGreen);
   SetIndexDrawBegin(3,KG-1);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexLabel(3,"Support H1");
   SetIndexArrow(3, 158);
   SetIndexStyle(4,DRAW_ARROW,STYLE_DOT,2,Blue);
   SetIndexDrawBegin(4,KG-1);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexLabel(4,"Resistance H4");
   SetIndexArrow(4, 158);
   SetIndexStyle(5,DRAW_ARROW,STYLE_DOT,2,Blue);
   SetIndexDrawBegin(5,KG-1);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexLabel(5,"Support H4");
   SetIndexArrow(5, 158);
   SetIndexStyle(6,DRAW_ARROW,STYLE_DOT,2,Red);
   SetIndexDrawBegin(6,KG-1);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexLabel(6,"Resistance D1");
   SetIndexArrow(6, 158);
   SetIndexStyle(7,DRAW_ARROW,STYLE_DOT,2,Red);
   SetIndexDrawBegin(7,KG-1);
   SetIndexBuffer(7,ExtMapBuffer8);
   SetIndexLabel(7,"Support D1");
   SetIndexArrow(7, 158);
//----

   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectDelete("Resistance M15");
   ObjectDelete("Support M15");
   ObjectDelete("Resistance H4");
   ObjectDelete("Support H4");
   ObjectDelete("Resistance H1");
   ObjectDelete("Support H1");
   ObjectDelete("Resistance D1");
   ObjectDelete("Support D1");

   return(0);
  }
//------------------------------------------------------------------  

int start()
  {
  
        
      LabelShiftTime = Time[LabelShift];
      
   int D1=1440, H4=240, H1=60, M15=15;
   KG=Bars;
   if(NewBar() == true){
      while(KG>=0)
      {
       if (Fractal("U",M15,KG)==1) ExtMapBuffer1[KG]=Close[KG];
       else ExtMapBuffer1[KG]=ExtMapBuffer1[KG+1];
       if (Fractal("L",M15,KG)==1) ExtMapBuffer2[KG]=Close[KG];
       else ExtMapBuffer2[KG]=ExtMapBuffer2[KG+1];
       if (Fractal("U",H1,KG)==1) ExtMapBuffer3[KG]=Close[KG];
       else ExtMapBuffer3[KG]=ExtMapBuffer3[KG+1];
       if (Fractal("L",H1,KG)==1) ExtMapBuffer4[KG]=Close[KG];
       else ExtMapBuffer4[KG]=ExtMapBuffer4[KG+1];
       if (Fractal("U",H4,KG)==1) ExtMapBuffer5[KG]=Close[KG];
       else ExtMapBuffer5[KG]=ExtMapBuffer5[KG+1];
       if (Fractal("L",H4,KG)==1) ExtMapBuffer6[KG]=Close[KG];
       else ExtMapBuffer6[KG]=ExtMapBuffer6[KG+1];
       if (Fractal("U",D1,KG)==1) ExtMapBuffer7[KG]=Close[KG];
       else ExtMapBuffer7[KG]=ExtMapBuffer7[KG+1];
       if (Fractal("L",D1,KG)==1) ExtMapBuffer8[KG]=Close[KG];
       else ExtMapBuffer8[KG]=ExtMapBuffer8[KG+1];
       KG--;
      }

      CreateObjects();
    }

//----

   return(0);
  }
  
  
//------------------------------------------------------------------  
  bool Fractal (string M,int P, int shift)
  {
   if (Period()>P) return(-1);
   P=P/Period()*2+MathCeil(P/Period()/2);
   if (shift<P)return(-1);
   if (shift>Bars-P)return(-1); 
   for (int i=1;i<=P;i++)
     {
      if (M=="U")
        {
         if (Close[shift+i]>Close[shift])return(-1);
         if (Close[shift-i]>=Close[shift])return(-1);     
        }
      if (M=="L")
        {
         if (Close[shift+i]<Close[shift])return(-1);
         if (Close[shift-i]<=Close[shift])return(-1);
        }        
     }
   return(1);   
  }  
//------------------------------------------------------------------
//+------------------------------------------------------------------+
void CreateObjects()
{
   ObjectDelete("Resistance M15");
   ObjectCreate("Resistance M15", OBJ_TEXT, 0, 1, 0);   
   ObjectSetText("Resistance M15", "                            " ,fontsize,"tahoma ",CLR_NONE);
   ObjectMove("Resistance M15", 0, LabelShiftTime, ExtMapBuffer1[1]);

   ObjectDelete("Support M15");
   ObjectCreate("Support M15", OBJ_TEXT, 0, 1, 0);   
   ObjectSetText("Support M15", "                            " ,fontsize,"tahoma ",CLR_NONE);
   ObjectMove("Support M15", 0, LabelShiftTime, ExtMapBuffer2[1]);

   ObjectDelete("Resistance H1");
   ObjectCreate("Resistance H1", OBJ_TEXT, 0, 1, 0);   
   ObjectSetText("Resistance H1", "                            " ,fontsize,"tahoma ",CLR_NONE);
   ObjectMove("Resistance H1", 0, LabelShiftTime, ExtMapBuffer3[1]);

   ObjectDelete("Support H1");
   ObjectCreate("Support H1", OBJ_TEXT, 0, 1, 0);   
   ObjectSetText("Support H1", "                            " ,fontsize,"tahoma ",CLR_NONE);
   ObjectMove("Support H1", 0, LabelShiftTime, ExtMapBuffer4[1]);

   ObjectDelete("Resistance H4");
   ObjectCreate("Resistance H4", OBJ_TEXT, 0, 1, 0);   
   ObjectSetText("Resistance H4", "                            " ,fontsize,"tahoma ",CLR_NONE);
   ObjectMove("Resistance H4", 0, LabelShiftTime, ExtMapBuffer5[1]);

   ObjectDelete("Support H4");
   ObjectCreate("Support H4", OBJ_TEXT, 0, 1, 0);   
   ObjectSetText("Support H4", "                            " ,fontsize,"tahoma ",CLR_NONE);
   ObjectMove("Support H4", 0, LabelShiftTime, ExtMapBuffer6[1]);

   ObjectDelete("Resistance D1");
   ObjectCreate("Resistance D1", OBJ_TEXT, 0, 1, 0);   
   ObjectSetText("Resistance D1", "                            " ,fontsize,"tahoma ",CLR_NONE);
   ObjectMove("Resistance D1", 0, LabelShiftTime, ExtMapBuffer7[1]);

   ObjectDelete("Support D1");
   ObjectCreate("Support D1", OBJ_TEXT, 0, 1, 0);   
   ObjectSetText("Support D1", "                            " ,fontsize,"tahoma ",CLR_NONE);
   ObjectMove("Support D1", 0, LabelShiftTime, ExtMapBuffer8[1]);

   return(0);
}

bool NewBar()
{
   static datetime lastbar = 0;
   datetime curbar = Time[0];
   if(lastbar!=curbar)
   {
      lastbar=curbar;
      return (true);
   }
   else
   {
      return(false);
   }
}

